#include <string>
#include <unordered_set>
#include <iostream>
#include <vector>
#include <sstream>

std::vector<size_t> parseMonitors(const std::string & str) {
    std::vector<size_t> resVector;
    std::stringstream sstr(str);
    std::string element;
    while (sstr) {
        std::getline(sstr, element);
        if (element[element.size() - 1] == '\n') {
            element = element.substr(0, element.size() - 1);
        }
        resVector.emplace_back(std::stoi(element));
    }
    return resVector;
}

std::vector<size_t> parseDesks(const std::string & str) {
    std::vector<size_t> resVector;
    std::stringstream sstr(str);
    std::string element;
    while (sstr) {
        std::getline(sstr, element);
        if (element[element.size() - 1] == '\n') {
            element = element.substr(0, element.size() - 1);
        }
        resVector.emplace_back(std::stoi(element));
    }
    return resVector;
}

struct Lab {
    size_t desks;
    size_t monitors;
    std::unordered_set<size_t> neighbours;
};

struct Facility {
    std::vector<Lab> labGraph;

    std::vector<std::string> parseDevice(const std::string & query);

    void addNeighbours(size_t lab1, size_t lab2);
    void addDevice(const std::string & device, size_t count);
    std::string getDomination(size_t labNumber);
};

int main() {

    return 0;
}
